// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

// DepIOSEnrollmentProfile The DepIOSEnrollmentProfile resource represents an Apple Device Enrollment Program (DEP) enrollment profile specific to iOS configuration. This type of profile must be assigned to Apple DEP serial numbers before the corresponding devices can enroll via DEP.
type DepIOSEnrollmentProfile struct {
	// DepEnrollmentBaseProfile is the base model of DepIOSEnrollmentProfile
	DepEnrollmentBaseProfile
	// ITunesPairingMode Indicates the iTunes pairing mode
	ITunesPairingMode *ITunesPairingMode `json:"iTunesPairingMode,omitempty"`
	// ManagementCertificates Management certificates for Apple Configurator
	ManagementCertificates []ManagementCertificateWithThumbprint `json:"managementCertificates,omitempty"`
	// RestoreFromAndroidDisabled Indicates if Restore from Android is disabled
	RestoreFromAndroidDisabled *bool `json:"restoreFromAndroidDisabled,omitempty"`
	// AwaitDeviceConfiguredConfirmation Indicates if the device will need to wait for configured confirmation
	AwaitDeviceConfiguredConfirmation *bool `json:"awaitDeviceConfiguredConfirmation,omitempty"`
	// SharedIPadMaximumUserCount This specifies the maximum number of users that can use a shared iPad. Only applicable in shared iPad mode.
	SharedIPadMaximumUserCount *int `json:"sharedIPadMaximumUserCount,omitempty"`
	// EnableSharedIPad This indicates whether the device is to be enrolled in a mode which enables multi user scenarios. Only applicable in shared iPads.
	EnableSharedIPad *bool `json:"enableSharedIPad,omitempty"`
	// CompanyPortalVppTokenID If set, indicates which Vpp token should be used to deploy the Company Portal w/ device licensing. 'enableAuthenticationViaCompanyPortal' must be set in order for this property to be set.
	CompanyPortalVppTokenID *string `json:"companyPortalVppTokenId,omitempty"`
	// EnableSingleAppEnrollmentMode Tells the device to enable single app mode and apply app-lock during enrollment. Default is false. 'enableAuthenticationViaCompanyPortal' and 'companyPortalVppTokenId' must be set for this property to be set.
	EnableSingleAppEnrollmentMode *bool `json:"enableSingleAppEnrollmentMode,omitempty"`
	// HomeButtonScreenDisabled Indicates if home button sensitivity screen is disabled
	HomeButtonScreenDisabled *bool `json:"homeButtonScreenDisabled,omitempty"`
	// IMessageAndFaceTimeScreenDisabled Indicates if iMessage and FaceTime screen is disabled
	IMessageAndFaceTimeScreenDisabled *bool `json:"iMessageAndFaceTimeScreenDisabled,omitempty"`
	// OnBoardingScreenDisabled Indicates if onboarding setup screen is disabled
	OnBoardingScreenDisabled *bool `json:"onBoardingScreenDisabled,omitempty"`
	// SimSetupScreenDisabled Indicates if the SIMSetup screen is disabled
	SimSetupScreenDisabled *bool `json:"simSetupScreenDisabled,omitempty"`
	// SoftwareUpdateScreenDisabled Indicates if the mandatory sofware update screen is disabled
	SoftwareUpdateScreenDisabled *bool `json:"softwareUpdateScreenDisabled,omitempty"`
	// WatchMigrationScreenDisabled Indicates if the watch migration screen is disabled
	WatchMigrationScreenDisabled *bool `json:"watchMigrationScreenDisabled,omitempty"`
	// AppearanceScreenDisabled Indicates if Apperance screen is disabled
	AppearanceScreenDisabled *bool `json:"appearanceScreenDisabled,omitempty"`
	// ExpressLanguageScreenDisabled Indicates if Express Language screen is disabled
	ExpressLanguageScreenDisabled *bool `json:"expressLanguageScreenDisabled,omitempty"`
	// PreferredLanguageScreenDisabled Indicates if Preferred language screen is disabled
	PreferredLanguageScreenDisabled *bool `json:"preferredLanguageScreenDisabled,omitempty"`
	// DeviceToDeviceMigrationDisabled Indicates if Device To Device Migration is disabled
	DeviceToDeviceMigrationDisabled *bool `json:"deviceToDeviceMigrationDisabled,omitempty"`
	// WelcomeScreenDisabled Indicates if Weclome screen is disabled
	WelcomeScreenDisabled *bool `json:"welcomeScreenDisabled,omitempty"`
}
