// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import "time"

// DeviceManagementScript Intune will provide customer the ability to run their Powershell scripts on the enrolled windows 10 Azure Active Directory joined devices. The script can be run once or periodically.
type DeviceManagementScript struct {
	// Entity is the base model of DeviceManagementScript
	Entity
	// DisplayName Name of the device management script.
	DisplayName *string `json:"displayName,omitempty"`
	// Description Optional description for the device management script.
	Description *string `json:"description,omitempty"`
	// ScriptContent The script content.
	ScriptContent *Binary `json:"scriptContent,omitempty"`
	// CreatedDateTime The date and time the device management script was created. This property is read-only.
	CreatedDateTime *time.Time `json:"createdDateTime,omitempty"`
	// LastModifiedDateTime The date and time the device management script was last modified. This property is read-only.
	LastModifiedDateTime *time.Time `json:"lastModifiedDateTime,omitempty"`
	// RunAsAccount Indicates the type of execution context.
	RunAsAccount *RunAsAccountType `json:"runAsAccount,omitempty"`
	// EnforceSignatureCheck Indicate whether the script signature needs be checked.
	EnforceSignatureCheck *bool `json:"enforceSignatureCheck,omitempty"`
	// FileName Script file name.
	FileName *string `json:"fileName,omitempty"`
	// RoleScopeTagIDs List of Scope Tag IDs for this PowerShellScript instance.
	RoleScopeTagIDs []string `json:"roleScopeTagIds,omitempty"`
	// RunAs32Bit A value indicating whether the PowerShell script should run as 32-bit
	RunAs32Bit *bool `json:"runAs32Bit,omitempty"`
	// GroupAssignments undocumented
	GroupAssignments []DeviceManagementScriptGroupAssignment `json:"groupAssignments,omitempty"`
	// Assignments undocumented
	Assignments []DeviceManagementScriptAssignment `json:"assignments,omitempty"`
	// RunSummary undocumented
	RunSummary *DeviceManagementScriptRunSummary `json:"runSummary,omitempty"`
	// DeviceRunStates undocumented
	DeviceRunStates []DeviceManagementScriptDeviceState `json:"deviceRunStates,omitempty"`
	// UserRunStates undocumented
	UserRunStates []DeviceManagementScriptUserState `json:"userRunStates,omitempty"`
}
