// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// DocumentRequestBuilder is request builder for Document
type DocumentRequestBuilder struct{ BaseRequestBuilder }

// Request returns DocumentRequest
func (b *DocumentRequestBuilder) Request() *DocumentRequest {
	return &DocumentRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// DocumentRequest is request for Document
type DocumentRequest struct{ BaseRequest }

// Get performs GET request for Document
func (r *DocumentRequest) Get(ctx context.Context) (resObj *Document, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for Document
func (r *DocumentRequest) Update(ctx context.Context, reqObj *Document) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for Document
func (r *DocumentRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// Comments returns request builder for DocumentComment collection
func (b *DocumentRequestBuilder) Comments() *DocumentCommentsCollectionRequestBuilder {
	bb := &DocumentCommentsCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/comments"
	return bb
}

// DocumentCommentsCollectionRequestBuilder is request builder for DocumentComment collection
type DocumentCommentsCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for DocumentComment collection
func (b *DocumentCommentsCollectionRequestBuilder) Request() *DocumentCommentsCollectionRequest {
	return &DocumentCommentsCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for DocumentComment item
func (b *DocumentCommentsCollectionRequestBuilder) ID(id string) *DocumentCommentRequestBuilder {
	bb := &DocumentCommentRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// DocumentCommentsCollectionRequest is request for DocumentComment collection
type DocumentCommentsCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for DocumentComment collection
func (r *DocumentCommentsCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]DocumentComment, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []DocumentComment
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []DocumentComment
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for DocumentComment collection
func (r *DocumentCommentsCollectionRequest) Get(ctx context.Context) ([]DocumentComment, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for DocumentComment collection
func (r *DocumentCommentsCollectionRequest) Add(ctx context.Context, reqObj *DocumentComment) (resObj *DocumentComment, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
