// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// InformationProtectionPolicyRequestBuilder is request builder for InformationProtectionPolicy
type InformationProtectionPolicyRequestBuilder struct{ BaseRequestBuilder }

// Request returns InformationProtectionPolicyRequest
func (b *InformationProtectionPolicyRequestBuilder) Request() *InformationProtectionPolicyRequest {
	return &InformationProtectionPolicyRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// InformationProtectionPolicyRequest is request for InformationProtectionPolicy
type InformationProtectionPolicyRequest struct{ BaseRequest }

// Get performs GET request for InformationProtectionPolicy
func (r *InformationProtectionPolicyRequest) Get(ctx context.Context) (resObj *InformationProtectionPolicy, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for InformationProtectionPolicy
func (r *InformationProtectionPolicyRequest) Update(ctx context.Context, reqObj *InformationProtectionPolicy) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for InformationProtectionPolicy
func (r *InformationProtectionPolicyRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// Labels returns request builder for InformationProtectionLabel collection
func (b *InformationProtectionPolicyRequestBuilder) Labels() *InformationProtectionPolicyLabelsCollectionRequestBuilder {
	bb := &InformationProtectionPolicyLabelsCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/labels"
	return bb
}

// InformationProtectionPolicyLabelsCollectionRequestBuilder is request builder for InformationProtectionLabel collection
type InformationProtectionPolicyLabelsCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for InformationProtectionLabel collection
func (b *InformationProtectionPolicyLabelsCollectionRequestBuilder) Request() *InformationProtectionPolicyLabelsCollectionRequest {
	return &InformationProtectionPolicyLabelsCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for InformationProtectionLabel item
func (b *InformationProtectionPolicyLabelsCollectionRequestBuilder) ID(id string) *InformationProtectionLabelRequestBuilder {
	bb := &InformationProtectionLabelRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// InformationProtectionPolicyLabelsCollectionRequest is request for InformationProtectionLabel collection
type InformationProtectionPolicyLabelsCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for InformationProtectionLabel collection
func (r *InformationProtectionPolicyLabelsCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]InformationProtectionLabel, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []InformationProtectionLabel
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []InformationProtectionLabel
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for InformationProtectionLabel collection
func (r *InformationProtectionPolicyLabelsCollectionRequest) Get(ctx context.Context) ([]InformationProtectionLabel, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for InformationProtectionLabel collection
func (r *InformationProtectionPolicyLabelsCollectionRequest) Add(ctx context.Context, reqObj *InformationProtectionLabel) (resObj *InformationProtectionLabel, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
