// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// JournalRequestBuilder is request builder for Journal
type JournalRequestBuilder struct{ BaseRequestBuilder }

// Request returns JournalRequest
func (b *JournalRequestBuilder) Request() *JournalRequest {
	return &JournalRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// JournalRequest is request for Journal
type JournalRequest struct{ BaseRequest }

// Get performs GET request for Journal
func (r *JournalRequest) Get(ctx context.Context) (resObj *Journal, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for Journal
func (r *JournalRequest) Update(ctx context.Context, reqObj *Journal) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for Journal
func (r *JournalRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// Account is navigation property
func (b *JournalRequestBuilder) Account() *AccountRequestBuilder {
	bb := &AccountRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/account"
	return bb
}

// JournalLines returns request builder for JournalLine collection
func (b *JournalRequestBuilder) JournalLines() *JournalJournalLinesCollectionRequestBuilder {
	bb := &JournalJournalLinesCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/journalLines"
	return bb
}

// JournalJournalLinesCollectionRequestBuilder is request builder for JournalLine collection
type JournalJournalLinesCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for JournalLine collection
func (b *JournalJournalLinesCollectionRequestBuilder) Request() *JournalJournalLinesCollectionRequest {
	return &JournalJournalLinesCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for JournalLine item
func (b *JournalJournalLinesCollectionRequestBuilder) ID(id string) *JournalLineRequestBuilder {
	bb := &JournalLineRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// JournalJournalLinesCollectionRequest is request for JournalLine collection
type JournalJournalLinesCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for JournalLine collection
func (r *JournalJournalLinesCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]JournalLine, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []JournalLine
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []JournalLine
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for JournalLine collection
func (r *JournalJournalLinesCollectionRequest) Get(ctx context.Context) ([]JournalLine, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for JournalLine collection
func (r *JournalJournalLinesCollectionRequest) Add(ctx context.Context, reqObj *JournalLine) (resObj *JournalLine, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
