// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// MacOsVppAppRequestBuilder is request builder for MacOsVppApp
type MacOsVppAppRequestBuilder struct{ BaseRequestBuilder }

// Request returns MacOsVppAppRequest
func (b *MacOsVppAppRequestBuilder) Request() *MacOsVppAppRequest {
	return &MacOsVppAppRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// MacOsVppAppRequest is request for MacOsVppApp
type MacOsVppAppRequest struct{ BaseRequest }

// Get performs GET request for MacOsVppApp
func (r *MacOsVppAppRequest) Get(ctx context.Context) (resObj *MacOsVppApp, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for MacOsVppApp
func (r *MacOsVppAppRequest) Update(ctx context.Context, reqObj *MacOsVppApp) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for MacOsVppApp
func (r *MacOsVppAppRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// AssignedLicenses returns request builder for MacOsVppAppAssignedLicense collection
func (b *MacOsVppAppRequestBuilder) AssignedLicenses() *MacOsVppAppAssignedLicensesCollectionRequestBuilder {
	bb := &MacOsVppAppAssignedLicensesCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/assignedLicenses"
	return bb
}

// MacOsVppAppAssignedLicensesCollectionRequestBuilder is request builder for MacOsVppAppAssignedLicense collection
type MacOsVppAppAssignedLicensesCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for MacOsVppAppAssignedLicense collection
func (b *MacOsVppAppAssignedLicensesCollectionRequestBuilder) Request() *MacOsVppAppAssignedLicensesCollectionRequest {
	return &MacOsVppAppAssignedLicensesCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for MacOsVppAppAssignedLicense item
func (b *MacOsVppAppAssignedLicensesCollectionRequestBuilder) ID(id string) *MacOsVppAppAssignedLicenseRequestBuilder {
	bb := &MacOsVppAppAssignedLicenseRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// MacOsVppAppAssignedLicensesCollectionRequest is request for MacOsVppAppAssignedLicense collection
type MacOsVppAppAssignedLicensesCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for MacOsVppAppAssignedLicense collection
func (r *MacOsVppAppAssignedLicensesCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]MacOsVppAppAssignedLicense, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []MacOsVppAppAssignedLicense
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []MacOsVppAppAssignedLicense
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for MacOsVppAppAssignedLicense collection
func (r *MacOsVppAppAssignedLicensesCollectionRequest) Get(ctx context.Context) ([]MacOsVppAppAssignedLicense, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for MacOsVppAppAssignedLicense collection
func (r *MacOsVppAppAssignedLicensesCollectionRequest) Add(ctx context.Context, reqObj *MacOsVppAppAssignedLicense) (resObj *MacOsVppAppAssignedLicense, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
