// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// OfficeConfigurationRequestBuilder is request builder for OfficeConfiguration
type OfficeConfigurationRequestBuilder struct{ BaseRequestBuilder }

// Request returns OfficeConfigurationRequest
func (b *OfficeConfigurationRequestBuilder) Request() *OfficeConfigurationRequest {
	return &OfficeConfigurationRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// OfficeConfigurationRequest is request for OfficeConfiguration
type OfficeConfigurationRequest struct{ BaseRequest }

// Get performs GET request for OfficeConfiguration
func (r *OfficeConfigurationRequest) Get(ctx context.Context) (resObj *OfficeConfiguration, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for OfficeConfiguration
func (r *OfficeConfigurationRequest) Update(ctx context.Context, reqObj *OfficeConfiguration) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for OfficeConfiguration
func (r *OfficeConfigurationRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// ClientConfigurations returns request builder for OfficeClientConfiguration collection
func (b *OfficeConfigurationRequestBuilder) ClientConfigurations() *OfficeConfigurationClientConfigurationsCollectionRequestBuilder {
	bb := &OfficeConfigurationClientConfigurationsCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/clientConfigurations"
	return bb
}

// OfficeConfigurationClientConfigurationsCollectionRequestBuilder is request builder for OfficeClientConfiguration collection
type OfficeConfigurationClientConfigurationsCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for OfficeClientConfiguration collection
func (b *OfficeConfigurationClientConfigurationsCollectionRequestBuilder) Request() *OfficeConfigurationClientConfigurationsCollectionRequest {
	return &OfficeConfigurationClientConfigurationsCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for OfficeClientConfiguration item
func (b *OfficeConfigurationClientConfigurationsCollectionRequestBuilder) ID(id string) *OfficeClientConfigurationRequestBuilder {
	bb := &OfficeClientConfigurationRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// OfficeConfigurationClientConfigurationsCollectionRequest is request for OfficeClientConfiguration collection
type OfficeConfigurationClientConfigurationsCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for OfficeClientConfiguration collection
func (r *OfficeConfigurationClientConfigurationsCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]OfficeClientConfiguration, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []OfficeClientConfiguration
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []OfficeClientConfiguration
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for OfficeClientConfiguration collection
func (r *OfficeConfigurationClientConfigurationsCollectionRequest) Get(ctx context.Context) ([]OfficeClientConfiguration, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for OfficeClientConfiguration collection
func (r *OfficeConfigurationClientConfigurationsCollectionRequest) Add(ctx context.Context, reqObj *OfficeClientConfiguration) (resObj *OfficeClientConfiguration, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
