// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// OutlookTaskGroupRequestBuilder is request builder for OutlookTaskGroup
type OutlookTaskGroupRequestBuilder struct{ BaseRequestBuilder }

// Request returns OutlookTaskGroupRequest
func (b *OutlookTaskGroupRequestBuilder) Request() *OutlookTaskGroupRequest {
	return &OutlookTaskGroupRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// OutlookTaskGroupRequest is request for OutlookTaskGroup
type OutlookTaskGroupRequest struct{ BaseRequest }

// Get performs GET request for OutlookTaskGroup
func (r *OutlookTaskGroupRequest) Get(ctx context.Context) (resObj *OutlookTaskGroup, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for OutlookTaskGroup
func (r *OutlookTaskGroupRequest) Update(ctx context.Context, reqObj *OutlookTaskGroup) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for OutlookTaskGroup
func (r *OutlookTaskGroupRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// TaskFolders returns request builder for OutlookTaskFolder collection
func (b *OutlookTaskGroupRequestBuilder) TaskFolders() *OutlookTaskGroupTaskFoldersCollectionRequestBuilder {
	bb := &OutlookTaskGroupTaskFoldersCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/taskFolders"
	return bb
}

// OutlookTaskGroupTaskFoldersCollectionRequestBuilder is request builder for OutlookTaskFolder collection
type OutlookTaskGroupTaskFoldersCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for OutlookTaskFolder collection
func (b *OutlookTaskGroupTaskFoldersCollectionRequestBuilder) Request() *OutlookTaskGroupTaskFoldersCollectionRequest {
	return &OutlookTaskGroupTaskFoldersCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for OutlookTaskFolder item
func (b *OutlookTaskGroupTaskFoldersCollectionRequestBuilder) ID(id string) *OutlookTaskFolderRequestBuilder {
	bb := &OutlookTaskFolderRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// OutlookTaskGroupTaskFoldersCollectionRequest is request for OutlookTaskFolder collection
type OutlookTaskGroupTaskFoldersCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for OutlookTaskFolder collection
func (r *OutlookTaskGroupTaskFoldersCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]OutlookTaskFolder, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []OutlookTaskFolder
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []OutlookTaskFolder
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for OutlookTaskFolder collection
func (r *OutlookTaskGroupTaskFoldersCollectionRequest) Get(ctx context.Context) ([]OutlookTaskFolder, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for OutlookTaskFolder collection
func (r *OutlookTaskGroupTaskFoldersCollectionRequest) Add(ctx context.Context, reqObj *OutlookTaskFolder) (resObj *OutlookTaskFolder, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
