// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// RiskyUserRequestBuilder is request builder for RiskyUser
type RiskyUserRequestBuilder struct{ BaseRequestBuilder }

// Request returns RiskyUserRequest
func (b *RiskyUserRequestBuilder) Request() *RiskyUserRequest {
	return &RiskyUserRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// RiskyUserRequest is request for RiskyUser
type RiskyUserRequest struct{ BaseRequest }

// Get performs GET request for RiskyUser
func (r *RiskyUserRequest) Get(ctx context.Context) (resObj *RiskyUser, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for RiskyUser
func (r *RiskyUserRequest) Update(ctx context.Context, reqObj *RiskyUser) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for RiskyUser
func (r *RiskyUserRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// History returns request builder for RiskyUserHistoryItem collection
func (b *RiskyUserRequestBuilder) History() *RiskyUserHistoryCollectionRequestBuilder {
	bb := &RiskyUserHistoryCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/history"
	return bb
}

// RiskyUserHistoryCollectionRequestBuilder is request builder for RiskyUserHistoryItem collection
type RiskyUserHistoryCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for RiskyUserHistoryItem collection
func (b *RiskyUserHistoryCollectionRequestBuilder) Request() *RiskyUserHistoryCollectionRequest {
	return &RiskyUserHistoryCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for RiskyUserHistoryItem item
func (b *RiskyUserHistoryCollectionRequestBuilder) ID(id string) *RiskyUserHistoryItemRequestBuilder {
	bb := &RiskyUserHistoryItemRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// RiskyUserHistoryCollectionRequest is request for RiskyUserHistoryItem collection
type RiskyUserHistoryCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for RiskyUserHistoryItem collection
func (r *RiskyUserHistoryCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]RiskyUserHistoryItem, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []RiskyUserHistoryItem
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []RiskyUserHistoryItem
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for RiskyUserHistoryItem collection
func (r *RiskyUserHistoryCollectionRequest) Get(ctx context.Context) ([]RiskyUserHistoryItem, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for RiskyUserHistoryItem collection
func (r *RiskyUserHistoryCollectionRequest) Add(ctx context.Context, reqObj *RiskyUserHistoryItem) (resObj *RiskyUserHistoryItem, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
