// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// WorkbookChartSeriesRequestBuilder is request builder for WorkbookChartSeries
type WorkbookChartSeriesRequestBuilder struct{ BaseRequestBuilder }

// Request returns WorkbookChartSeriesRequest
func (b *WorkbookChartSeriesRequestBuilder) Request() *WorkbookChartSeriesRequest {
	return &WorkbookChartSeriesRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// WorkbookChartSeriesRequest is request for WorkbookChartSeries
type WorkbookChartSeriesRequest struct{ BaseRequest }

// Get performs GET request for WorkbookChartSeries
func (r *WorkbookChartSeriesRequest) Get(ctx context.Context) (resObj *WorkbookChartSeries, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for WorkbookChartSeries
func (r *WorkbookChartSeriesRequest) Update(ctx context.Context, reqObj *WorkbookChartSeries) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for WorkbookChartSeries
func (r *WorkbookChartSeriesRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// Format is navigation property
func (b *WorkbookChartSeriesRequestBuilder) Format() *WorkbookChartSeriesFormatRequestBuilder {
	bb := &WorkbookChartSeriesFormatRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/format"
	return bb
}

// Points returns request builder for WorkbookChartPoint collection
func (b *WorkbookChartSeriesRequestBuilder) Points() *WorkbookChartSeriesPointsCollectionRequestBuilder {
	bb := &WorkbookChartSeriesPointsCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/points"
	return bb
}

// WorkbookChartSeriesPointsCollectionRequestBuilder is request builder for WorkbookChartPoint collection
type WorkbookChartSeriesPointsCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for WorkbookChartPoint collection
func (b *WorkbookChartSeriesPointsCollectionRequestBuilder) Request() *WorkbookChartSeriesPointsCollectionRequest {
	return &WorkbookChartSeriesPointsCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for WorkbookChartPoint item
func (b *WorkbookChartSeriesPointsCollectionRequestBuilder) ID(id string) *WorkbookChartPointRequestBuilder {
	bb := &WorkbookChartPointRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// WorkbookChartSeriesPointsCollectionRequest is request for WorkbookChartPoint collection
type WorkbookChartSeriesPointsCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for WorkbookChartPoint collection
func (r *WorkbookChartSeriesPointsCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]WorkbookChartPoint, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []WorkbookChartPoint
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []WorkbookChartPoint
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for WorkbookChartPoint collection
func (r *WorkbookChartSeriesPointsCollectionRequest) Get(ctx context.Context) ([]WorkbookChartPoint, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for WorkbookChartPoint collection
func (r *WorkbookChartSeriesPointsCollectionRequest) Add(ctx context.Context, reqObj *WorkbookChartPoint) (resObj *WorkbookChartPoint, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
