// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// AppVulnerabilityTaskRequestBuilder is request builder for AppVulnerabilityTask
type AppVulnerabilityTaskRequestBuilder struct{ BaseRequestBuilder }

// Request returns AppVulnerabilityTaskRequest
func (b *AppVulnerabilityTaskRequestBuilder) Request() *AppVulnerabilityTaskRequest {
	return &AppVulnerabilityTaskRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// AppVulnerabilityTaskRequest is request for AppVulnerabilityTask
type AppVulnerabilityTaskRequest struct{ BaseRequest }

// Get performs GET request for AppVulnerabilityTask
func (r *AppVulnerabilityTaskRequest) Get(ctx context.Context) (resObj *AppVulnerabilityTask, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for AppVulnerabilityTask
func (r *AppVulnerabilityTaskRequest) Update(ctx context.Context, reqObj *AppVulnerabilityTask) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for AppVulnerabilityTask
func (r *AppVulnerabilityTaskRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// ManagedDevices returns request builder for AppVulnerabilityManagedDevice collection
func (b *AppVulnerabilityTaskRequestBuilder) ManagedDevices() *AppVulnerabilityTaskManagedDevicesCollectionRequestBuilder {
	bb := &AppVulnerabilityTaskManagedDevicesCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/managedDevices"
	return bb
}

// AppVulnerabilityTaskManagedDevicesCollectionRequestBuilder is request builder for AppVulnerabilityManagedDevice collection
type AppVulnerabilityTaskManagedDevicesCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for AppVulnerabilityManagedDevice collection
func (b *AppVulnerabilityTaskManagedDevicesCollectionRequestBuilder) Request() *AppVulnerabilityTaskManagedDevicesCollectionRequest {
	return &AppVulnerabilityTaskManagedDevicesCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for AppVulnerabilityManagedDevice item
func (b *AppVulnerabilityTaskManagedDevicesCollectionRequestBuilder) ID(id string) *AppVulnerabilityManagedDeviceRequestBuilder {
	bb := &AppVulnerabilityManagedDeviceRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// AppVulnerabilityTaskManagedDevicesCollectionRequest is request for AppVulnerabilityManagedDevice collection
type AppVulnerabilityTaskManagedDevicesCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for AppVulnerabilityManagedDevice collection
func (r *AppVulnerabilityTaskManagedDevicesCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]AppVulnerabilityManagedDevice, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []AppVulnerabilityManagedDevice
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []AppVulnerabilityManagedDevice
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for AppVulnerabilityManagedDevice collection
func (r *AppVulnerabilityTaskManagedDevicesCollectionRequest) Get(ctx context.Context) ([]AppVulnerabilityManagedDevice, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for AppVulnerabilityManagedDevice collection
func (r *AppVulnerabilityTaskManagedDevicesCollectionRequest) Add(ctx context.Context, reqObj *AppVulnerabilityManagedDevice) (resObj *AppVulnerabilityManagedDevice, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}

// MobileApps returns request builder for AppVulnerabilityMobileApp collection
func (b *AppVulnerabilityTaskRequestBuilder) MobileApps() *AppVulnerabilityTaskMobileAppsCollectionRequestBuilder {
	bb := &AppVulnerabilityTaskMobileAppsCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/mobileApps"
	return bb
}

// AppVulnerabilityTaskMobileAppsCollectionRequestBuilder is request builder for AppVulnerabilityMobileApp collection
type AppVulnerabilityTaskMobileAppsCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for AppVulnerabilityMobileApp collection
func (b *AppVulnerabilityTaskMobileAppsCollectionRequestBuilder) Request() *AppVulnerabilityTaskMobileAppsCollectionRequest {
	return &AppVulnerabilityTaskMobileAppsCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for AppVulnerabilityMobileApp item
func (b *AppVulnerabilityTaskMobileAppsCollectionRequestBuilder) ID(id string) *AppVulnerabilityMobileAppRequestBuilder {
	bb := &AppVulnerabilityMobileAppRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// AppVulnerabilityTaskMobileAppsCollectionRequest is request for AppVulnerabilityMobileApp collection
type AppVulnerabilityTaskMobileAppsCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for AppVulnerabilityMobileApp collection
func (r *AppVulnerabilityTaskMobileAppsCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]AppVulnerabilityMobileApp, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []AppVulnerabilityMobileApp
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []AppVulnerabilityMobileApp
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for AppVulnerabilityMobileApp collection
func (r *AppVulnerabilityTaskMobileAppsCollectionRequest) Get(ctx context.Context) ([]AppVulnerabilityMobileApp, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for AppVulnerabilityMobileApp collection
func (r *AppVulnerabilityTaskMobileAppsCollectionRequest) Add(ctx context.Context, reqObj *AppVulnerabilityMobileApp) (resObj *AppVulnerabilityMobileApp, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
