// Code generated by msgraph-generate.go DO NOT EDIT.

package msgraph

import (
	"context"
	"fmt"
	"io/ioutil"
	"net/http"

	"github.com/yaegashi/msgraph.go/jsonx"
)

// WindowsMalwareInformationRequestBuilder is request builder for WindowsMalwareInformation
type WindowsMalwareInformationRequestBuilder struct{ BaseRequestBuilder }

// Request returns WindowsMalwareInformationRequest
func (b *WindowsMalwareInformationRequestBuilder) Request() *WindowsMalwareInformationRequest {
	return &WindowsMalwareInformationRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// WindowsMalwareInformationRequest is request for WindowsMalwareInformation
type WindowsMalwareInformationRequest struct{ BaseRequest }

// Get performs GET request for WindowsMalwareInformation
func (r *WindowsMalwareInformationRequest) Get(ctx context.Context) (resObj *WindowsMalwareInformation, err error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	err = r.JSONRequest(ctx, "GET", query, nil, &resObj)
	return
}

// Update performs PATCH request for WindowsMalwareInformation
func (r *WindowsMalwareInformationRequest) Update(ctx context.Context, reqObj *WindowsMalwareInformation) error {
	return r.JSONRequest(ctx, "PATCH", "", reqObj, nil)
}

// Delete performs DELETE request for WindowsMalwareInformation
func (r *WindowsMalwareInformationRequest) Delete(ctx context.Context) error {
	return r.JSONRequest(ctx, "DELETE", "", nil, nil)
}

// WindowsDevicesProtectionState returns request builder for WindowsProtectionState collection
func (b *WindowsMalwareInformationRequestBuilder) WindowsDevicesProtectionState() *WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequestBuilder {
	bb := &WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/windowsDevicesProtectionState"
	return bb
}

// WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequestBuilder is request builder for WindowsProtectionState collection
type WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequestBuilder struct{ BaseRequestBuilder }

// Request returns request for WindowsProtectionState collection
func (b *WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequestBuilder) Request() *WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequest {
	return &WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequest{
		BaseRequest: BaseRequest{baseURL: b.baseURL, client: b.client},
	}
}

// ID returns request builder for WindowsProtectionState item
func (b *WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequestBuilder) ID(id string) *WindowsProtectionStateRequestBuilder {
	bb := &WindowsProtectionStateRequestBuilder{BaseRequestBuilder: b.BaseRequestBuilder}
	bb.baseURL += "/" + id
	return bb
}

// WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequest is request for WindowsProtectionState collection
type WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequest struct{ BaseRequest }

// Paging perfoms paging operation for WindowsProtectionState collection
func (r *WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequest) Paging(ctx context.Context, method, path string, obj interface{}) ([]WindowsProtectionState, error) {
	req, err := r.NewJSONRequest(method, path, obj)
	if err != nil {
		return nil, err
	}
	if ctx != nil {
		req = req.WithContext(ctx)
	}
	res, err := r.client.Do(req)
	if err != nil {
		return nil, err
	}
	var values []WindowsProtectionState
	for {
		defer res.Body.Close()
		if res.StatusCode != http.StatusOK {
			b, _ := ioutil.ReadAll(res.Body)
			errRes := &ErrorResponse{Response: res}
			err := jsonx.Unmarshal(b, errRes)
			if err != nil {
				return nil, fmt.Errorf("%s: %s", res.Status, string(b))
			}
			return nil, errRes
		}
		var (
			paging Paging
			value  []WindowsProtectionState
		)
		err := jsonx.NewDecoder(res.Body).Decode(&paging)
		if err != nil {
			return nil, err
		}
		err = jsonx.Unmarshal(paging.Value, &value)
		if err != nil {
			return nil, err
		}
		values = append(values, value...)
		if len(paging.NextLink) == 0 {
			return values, nil
		}
		req, err = http.NewRequest("GET", paging.NextLink, nil)
		if ctx != nil {
			req = req.WithContext(ctx)
		}
		res, err = r.client.Do(req)
		if err != nil {
			return nil, err
		}
	}
}

// Get performs GET request for WindowsProtectionState collection
func (r *WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequest) Get(ctx context.Context) ([]WindowsProtectionState, error) {
	var query string
	if r.query != nil {
		query = "?" + r.query.Encode()
	}
	return r.Paging(ctx, "GET", query, nil)
}

// Add performs POST request for WindowsProtectionState collection
func (r *WindowsMalwareInformationWindowsDevicesProtectionStateCollectionRequest) Add(ctx context.Context, reqObj *WindowsProtectionState) (resObj *WindowsProtectionState, err error) {
	err = r.JSONRequest(ctx, "POST", "", reqObj, &resObj)
	return
}
